<?php

/*
Plugin Name: User list widget
Plugin URI: http://zaantar.eu
Description: Widget obsahující seznam všech uživatelů přihlášených na daném blogu. <strong>Vyvinuto a určeno pro blogosphere.cz</strong>
Version: 1.0
Author: Zaantar
Author URI: http://zaantar.eu
License: GPL2
*/

/*
    Copyright 2010 Zaantar (email: zaantar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* ************************************************************************* *\
    WORDPRESS HOOKS
\* ************************************************************************* */



/* ************************************************************************* *\
    WIDGET CLASS
\* ************************************************************************* */

class UserList_Widget extends WP_Widget {
    /** constructor */
    function UserList_Widget() {
        parent::WP_Widget(false, $name = 'User List Widget');	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {		
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
        $before_list = $instance['before_list'];
        $before_user = $instance['before_user'];
        $after_user = $instance['after_user'];
        $after_list = $instance['after_list'];
        ?>
              <?php echo $before_widget; ?>
                  <?php if ( $title )
                        echo $before_title . $title . $after_title; ?>
                  <?php $this->print_user_list( $before_list, $before_user, $after_user, $after_list ); ?>
              <?php echo $after_widget; ?>
        <?php
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['before_list'] = $new_instance['before_list'];
		$instance['before_user'] = $new_instance['before_user'];
		$instance['after_user'] = $new_instance['after_user'];
		$instance['after_list'] = $new_instance['after_list'];
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $title = esc_attr($instance['title']);
        $before_list = $instance['before_list'];
        $before_user = $instance['before_user'];
        $after_user = $instance['after_user'];
        $after_list = $instance['after_list'];
        ?>
            <p>
            	<label for="<?php echo $this->get_field_id('title'); ?>">
            		<?php _e('Title:'); ?> 
            	</label>
            	<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" 
            		name="<?php echo $this->get_field_name('title'); ?>" 
            		type="text" value="<?php echo $title; ?>" />
            </p>
            <p>
            	<label for="<?php echo $this->get_field_id('before_list'); ?>">
            		<?php _e('Before user list:'); ?> 
            	</label>
            	<input class="widefat" id="<?php echo $this->get_field_id('before_list'); ?>" 
            		name="<?php echo $this->get_field_name('before_list'); ?>" 
            		type="text" value="<?php echo $before_list; ?>" />
            </p>
            <p>
            	<label for="<?php echo $this->get_field_id('before_user'); ?>">
            		<?php _e('Before user entry:'); ?> 
            	</label>
            	<input class="widefat" id="<?php echo $this->get_field_id('before_user'); ?>" 
            		name="<?php echo $this->get_field_name('before_user'); ?>" 
            		type="text" value="<?php echo $before_user; ?>" />
            </p>
            <p>
            	<label for="<?php echo $this->get_field_id('after_user'); ?>">
            		<?php _e('After user entry:'); ?> 
            	</label>
            	<input class="widefat" id="<?php echo $this->get_field_id('after_user'); ?>" 
            		name="<?php echo $this->get_field_name('after_user'); ?>" 
            		type="text" value="<?php echo $after_user; ?>" />
            </p> 
            <p>
            	<label for="<?php echo $this->get_field_id('after_list'); ?>">
            		<?php _e('After user list:'); ?> 
            	</label>
            	<input class="widefat" id="<?php echo $this->get_field_id('after_list'); ?>" 
            		name="<?php echo $this->get_field_name('after_list'); ?>" 
            		type="text" value="<?php echo $after_list; ?>" />
            </p>          
        <?php 
    }
    
    function print_user_list( $before_list, $before_user, $after_user, $after_list ) {
    	/* získáme seznam uživatelů */
    	$users = get_users_of_blog();
    	
    	/* výpis do widgetu */
    	echo( $before_list );
    	foreach( $users as $user ) {
    		$display_name = $user->display_name;
    		$user_login = $user->user_login;
    		echo( $before_user );
    		echo( $display_name );
    		if( $display_name != $user_login ) {
    			echo( ' ('.$user->user_login.')' );
    		}
    		echo( $after_user ); 
    	}
    	echo( $after_list );
    }

}

add_action('widgets_init', create_function('', 'return register_widget("UserList_Widget");'));


?>
